Loading...
Searching...
No Matches
itk::AdvancedRayCastInterpolateImageFunction< TInputImage, TCoordRep > Class Template Reference

`#include <itkAdvancedRayCastInterpolateImageFunction.h>`

## Detailed Description

template<class TInputImage, class TCoordRep = double>
class itk::AdvancedRayCastInterpolateImageFunction< TInputImage, TCoordRep >

Projective interpolation of an image at specified positions.

AdvancedRayCastInterpolateImageFunction casts rays through a 3-dimensional image and uses bilinear interpolation to integrate each plane of voxels traversed.

Warning
  This interpolator works for 3-dimensional images only.

Definition at line 56 of file itkAdvancedRayCastInterpolateImageFunction.h.

Inheritance diagram for itk::AdvancedRayCastInterpolateImageFunction< TInputImage, TCoordRep >:
[legend]

## Public Types

using | ConstPointer = SmartPointer<const Self>
using | DirectionType = Vector<TCoordRep, InputImageDimension>
using | InputPointType = typename TransformType::InputPointType
using | InterpolatorPointer = typename InterpolatorType::Pointer
using | InterpolatorType = InterpolateImageFunction<TInputImage, TCoordRep>
using | OutputPointType = typename TransformType::OutputPointType
using | Pointer = SmartPointer<Self>
using | Self = AdvancedRayCastInterpolateImageFunction
using | SizeType = typename TInputImage::SizeType
using | Superclass = InterpolateImageFunction<TInputImage, TCoordRep>
using | TransformJacobianType = typename TransformType::JacobianType
using | TransformParametersType = typename TransformType::ParametersType
using | TransformPointer = typename TransformType::Pointer
using | TransformType = Transform<TCoordRep, InputImageDimension, InputImageDimension>

## Public Member Functions

OutputType | Evaluate (const PointType &point) const override
OutputType | EvaluateAtContinuousIndex (const ContinuousIndexType &index) const override
virtual const char * | GetClassName () const
virtual InputPointType | GetFocalPoint () const
virtual double | GetThreshold () const
bool | IsInsideBuffer (const ContinuousIndexType &) const override
bool | IsInsideBuffer (const IndexType &) const override
bool | IsInsideBuffer (const PointType &) const override
| ITK_DISALLOW_COPY_AND_MOVE (AdvancedRayCastInterpolateImageFunction)
| itkGetModifiableObjectMacro (Interpolator, InterpolatorType)
| itkGetModifiableObjectMacro (Transform, TransformType)
| itkStaticConstMacro (ImageDimension, unsigned int, Superclass::ImageDimension)
| itkStaticConstMacro (InputImageDimension, unsigned int, TInputImage::ImageDimension)
virtual void | SetFocalPoint (InputPointType _arg)
virtual void | SetInterpolator (InterpolatorType *_arg)
virtual void | SetThreshold (double _arg)
virtual void | SetTransform (TransformType *_arg)

## Static Public Member Functions

static Pointer | New ()

## Protected Member Functions

| AdvancedRayCastInterpolateImageFunction ()=default
void | PrintSelf (std::ostream &os, Indent indent) const override
| ~AdvancedRayCastInterpolateImageFunction () override=default

## Protected Attributes

InputPointType | m_FocalPoint {}
InterpolatorPointer | m_Interpolator {}
double | m_Threshold { 0.0 }
TransformPointer | m_Transform {}

## Private Member Functions

SizeType | GetRadius () const override

## Member Typedef Documentation

## ConstPointer

template<class TInputImage, class TCoordRep = double>

using itk::AdvancedRayCastInterpolateImageFunction< TInputImage, TCoordRep >::ConstPointer = SmartPointer<const Self>

Definition at line 66 of file itkAdvancedRayCastInterpolateImageFunction.h.

## DirectionType

template<class TInputImage, class TCoordRep = double>

using itk::AdvancedRayCastInterpolateImageFunction< TInputImage, TCoordRep >::DirectionType = Vector<TCoordRep, InputImageDimension>

Definition at line 87 of file itkAdvancedRayCastInterpolateImageFunction.h.

## InputPointType

template<class TInputImage, class TCoordRep = double>

using itk::AdvancedRayCastInterpolateImageFunction< TInputImage, TCoordRep >::InputPointType = typename TransformType::InputPointType

Definition at line 78 of file itkAdvancedRayCastInterpolateImageFunction.h.

## InterpolatorPointer

template<class TInputImage, class TCoordRep = double>

using itk::AdvancedRayCastInterpolateImageFunction< TInputImage, TCoordRep >::InterpolatorPointer = typename InterpolatorType::Pointer

Definition at line 92 of file itkAdvancedRayCastInterpolateImageFunction.h.

## InterpolatorType

template<class TInputImage, class TCoordRep = double>

using itk::AdvancedRayCastInterpolateImageFunction< TInputImage, TCoordRep >::InterpolatorType = InterpolateImageFunction<TInputImage, TCoordRep>

Type of the Interpolator Base class

Definition at line 90 of file itkAdvancedRayCastInterpolateImageFunction.h.

## OutputPointType

template<class TInputImage, class TCoordRep = double>

using itk::AdvancedRayCastInterpolateImageFunction< TInputImage, TCoordRep >::OutputPointType = typename TransformType::OutputPointType

Definition at line 79 of file itkAdvancedRayCastInterpolateImageFunction.h.

## Pointer

template<class TInputImage, class TCoordRep = double>

using itk::AdvancedRayCastInterpolateImageFunction< TInputImage, TCoordRep >::Pointer = SmartPointer<Self>

Definition at line 65 of file itkAdvancedRayCastInterpolateImageFunction.h.

## Self

template<class TInputImage, class TCoordRep = double>

using itk::AdvancedRayCastInterpolateImageFunction< TInputImage, TCoordRep >::Self = AdvancedRayCastInterpolateImageFunction

Standard class typedefs.

Definition at line 63 of file itkAdvancedRayCastInterpolateImageFunction.h.

## SizeType

template<class TInputImage, class TCoordRep = double>

using itk::AdvancedRayCastInterpolateImageFunction< TInputImage, TCoordRep >::SizeType = typename TInputImage::SizeType

Definition at line 85 of file itkAdvancedRayCastInterpolateImageFunction.h.

## Superclass

template<class TInputImage, class TCoordRep = double>

using itk::AdvancedRayCastInterpolateImageFunction< TInputImage, TCoordRep >::Superclass = InterpolateImageFunction<TInputImage, TCoordRep>

Definition at line 64 of file itkAdvancedRayCastInterpolateImageFunction.h.

## TransformJacobianType

template<class TInputImage, class TCoordRep = double>

using itk::AdvancedRayCastInterpolateImageFunction< TInputImage, TCoordRep >::TransformJacobianType = typename TransformType::JacobianType

Definition at line 81 of file itkAdvancedRayCastInterpolateImageFunction.h.

## TransformParametersType

template<class TInputImage, class TCoordRep = double>

using itk::AdvancedRayCastInterpolateImageFunction< TInputImage, TCoordRep >::TransformParametersType = typename TransformType::ParametersType

Definition at line 80 of file itkAdvancedRayCastInterpolateImageFunction.h.

## TransformPointer

template<class TInputImage, class TCoordRep = double>

using itk::AdvancedRayCastInterpolateImageFunction< TInputImage, TCoordRep >::TransformPointer = typename TransformType::Pointer

Definition at line 77 of file itkAdvancedRayCastInterpolateImageFunction.h.

## TransformType

template<class TInputImage, class TCoordRep = double>

using itk::AdvancedRayCastInterpolateImageFunction< TInputImage, TCoordRep >::TransformType = Transform<TCoordRep, InputImageDimension, InputImageDimension>

Type of the Transform Base class The fixed image should be a 3D image

Definition at line 75 of file itkAdvancedRayCastInterpolateImageFunction.h.

## Constructor & Destructor Documentation

## AdvancedRayCastInterpolateImageFunction()

template<class TInputImage, class TCoordRep = double>

itk::AdvancedRayCastInterpolateImageFunction< TInputImage, TCoordRep >::AdvancedRayCastInterpolateImageFunction | ( |  | ) |

protected default

Constructor.

## ~AdvancedRayCastInterpolateImageFunction()

template<class TInputImage, class TCoordRep = double>

itk::AdvancedRayCastInterpolateImageFunction< TInputImage, TCoordRep >::~AdvancedRayCastInterpolateImageFunction | ( |  | ) |

override protected default

Destructor.

## Member Function Documentation

## Evaluate()

template<class TInputImage, class TCoordRep = double>

OutputType itk::AdvancedRayCastInterpolateImageFunction< TInputImage, TCoordRep >::Evaluate | ( | const PointType & | point | ) | const

override

Interpolate the image at a point position.

Returns the interpolated image intensity at a specified point position. No bounds checking is done. The point is assume to lie within the image buffer.

ImageFunction::IsInsideBuffer() can be used to check bounds before calling the method.

## EvaluateAtContinuousIndex()

template<class TInputImage, class TCoordRep = double>

OutputType itk::AdvancedRayCastInterpolateImageFunction< TInputImage, TCoordRep >::EvaluateAtContinuousIndex | ( | const ContinuousIndexType & | index | ) | const

override

Interpolate the image at a continuous index position

Returns the interpolated image intensity at a specified index position. No bounds checking is done. The point is assume to lie within the image buffer.

Subclasses must override this method.

ImageFunction::IsInsideBuffer() can be used to check bounds before calling the method.

## GetClassName()

template<class TInputImage, class TCoordRep = double>

virtual const char * itk::AdvancedRayCastInterpolateImageFunction< TInputImage, TCoordRep >::GetClassName | ( |  | ) | const

virtual

Run-time type information (and related methods).

Reimplemented in elastix::RayCastInterpolator< TElastix >, and elastix::RayCastResampleInterpolator< TElastix >.

## GetFocalPoint()

template<class TInputImage, class TCoordRep = double>

virtual InputPointType itk::AdvancedRayCastInterpolateImageFunction< TInputImage, TCoordRep >::GetFocalPoint | ( |  | ) | const

virtual

Get a pointer to the Interpolator.

## GetRadius()

template<class TInputImage, class TCoordRep = double>

SizeType itk::AdvancedRayCastInterpolateImageFunction< TInputImage, TCoordRep >::GetRadius | ( |  | ) | const

inline override private

Definition at line 217 of file itkAdvancedRayCastInterpolateImageFunction.h.

## GetThreshold()

template<class TInputImage, class TCoordRep = double>

virtual double itk::AdvancedRayCastInterpolateImageFunction< TInputImage, TCoordRep >::GetThreshold | ( |  | ) | const

virtual

Get a pointer to the Transform.

## IsInsideBuffer() [1/3]

template<class TInputImage, class TCoordRep = double>

bool itk::AdvancedRayCastInterpolateImageFunction< TInputImage, TCoordRep >::IsInsideBuffer | ( | const ContinuousIndexType & |  | ) | const

inline override

Definition at line 179 of file itkAdvancedRayCastInterpolateImageFunction.h.

## IsInsideBuffer() [2/3]

template<class TInputImage, class TCoordRep = double>

bool itk::AdvancedRayCastInterpolateImageFunction< TInputImage, TCoordRep >::IsInsideBuffer | ( | const IndexType & |  | ) | const

inline override

Definition at line 186 of file itkAdvancedRayCastInterpolateImageFunction.h.

## IsInsideBuffer() [3/3]

template<class TInputImage, class TCoordRep = double>

bool itk::AdvancedRayCastInterpolateImageFunction< TInputImage, TCoordRep >::IsInsideBuffer | ( | const PointType & |  | ) | const

inline override

Check if a point is inside the image buffer.

Warning
  For efficiency, no validity checking of the input image pointer is done.

Definition at line 172 of file itkAdvancedRayCastInterpolateImageFunction.h.

## ITK_DISALLOW_COPY_AND_MOVE()

template<class TInputImage, class TCoordRep = double>

itk::AdvancedRayCastInterpolateImageFunction< TInputImage, TCoordRep >::ITK_DISALLOW_COPY_AND_MOVE | ( | AdvancedRayCastInterpolateImageFunction< TInputImage, TCoordRep > |  | ) |

## itkGetModifiableObjectMacro() [1/2]

template<class TInputImage, class TCoordRep = double>

itk::AdvancedRayCastInterpolateImageFunction< TInputImage, TCoordRep >::itkGetModifiableObjectMacro | ( | Interpolator | ,
|  | InterpolatorType | )

Get a pointer to the Interpolator.

## itkGetModifiableObjectMacro() [2/2]

template<class TInputImage, class TCoordRep = double>

itk::AdvancedRayCastInterpolateImageFunction< TInputImage, TCoordRep >::itkGetModifiableObjectMacro | ( | Transform | ,
|  | TransformType | )

Get a pointer to the Transform.

## itkStaticConstMacro() [1/2]

template<class TInputImage, class TCoordRep = double>

itk::AdvancedRayCastInterpolateImageFunction< TInputImage, TCoordRep >::itkStaticConstMacro | ( | ImageDimension | ,
|  | unsigned int | ,
|  | Superclass::ImageDimension | )

Dimension underlying input image.

## itkStaticConstMacro() [2/2]

template<class TInputImage, class TCoordRep = double>

itk::AdvancedRayCastInterpolateImageFunction< TInputImage, TCoordRep >::itkStaticConstMacro | ( | InputImageDimension | ,
|  | unsigned int | ,
|  | TInputImage::ImageDimension | )

Constants for the image dimensions

## New()

template<class TInputImage, class TCoordRep = double>

Pointer itk::AdvancedRayCastInterpolateImageFunction< TInputImage, TCoordRep >::New | ( |  | ) |

static

Method for creation through the object factory.

## PrintSelf()

template<class TInputImage, class TCoordRep = double>

void itk::AdvancedRayCastInterpolateImageFunction< TInputImage, TCoordRep >::PrintSelf | ( | std::ostream & | os,
|  | Indent | indent ) const

override protected

Print the object.

## SetFocalPoint()

template<class TInputImage, class TCoordRep = double>

virtual void itk::AdvancedRayCastInterpolateImageFunction< TInputImage, TCoordRep >::SetFocalPoint | ( | InputPointType | _arg | ) |

virtual

Connect the Interpolator.

## SetInterpolator()

template<class TInputImage, class TCoordRep = double>

virtual void itk::AdvancedRayCastInterpolateImageFunction< TInputImage, TCoordRep >::SetInterpolator | ( | InterpolatorType * | _arg | ) |

virtual

Connect the Interpolator.

## SetThreshold()

template<class TInputImage, class TCoordRep = double>

virtual void itk::AdvancedRayCastInterpolateImageFunction< TInputImage, TCoordRep >::SetThreshold | ( | double | _arg | ) |

virtual

Connect the Transform.

## SetTransform()

template<class TInputImage, class TCoordRep = double>

virtual void itk::AdvancedRayCastInterpolateImageFunction< TInputImage, TCoordRep >::SetTransform | ( | TransformType * | _arg | ) |

virtual

Connect the Transform.

## Field Documentation

## m_FocalPoint

template<class TInputImage, class TCoordRep = double>

InputPointType itk::AdvancedRayCastInterpolateImageFunction< TInputImage, TCoordRep >::m_FocalPoint {}

protected

The focal point or position of the ray source.

Definition at line 207 of file itkAdvancedRayCastInterpolateImageFunction.h.

## m_Interpolator

template<class TInputImage, class TCoordRep = double>

InterpolatorPointer itk::AdvancedRayCastInterpolateImageFunction< TInputImage, TCoordRep >::m_Interpolator {}

protected

Pointer to the interpolator.

Definition at line 213 of file itkAdvancedRayCastInterpolateImageFunction.h.

## m_Threshold

template<class TInputImage, class TCoordRep = double>

double itk::AdvancedRayCastInterpolateImageFunction< TInputImage, TCoordRep >::m_Threshold { 0.0 }

protected

The threshold above which voxels along the ray path are integrated.

Definition at line 210 of file itkAdvancedRayCastInterpolateImageFunction.h.

## m_Transform

template<class TInputImage, class TCoordRep = double>

TransformPointer itk::AdvancedRayCastInterpolateImageFunction< TInputImage, TCoordRep >::m_Transform {}

protected

Transformation used to calculate the new focal point position.

Definition at line 204 of file itkAdvancedRayCastInterpolateImageFunction.h.

Generated on 1768596610 for elastix by 1.15.0 |